//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Application\CWinInit.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CWININIT_H
#define CWININIT_H

#include <Windows.h>
#include "..\Globals\CGlobals.h"
#include "..\Utilities\CDebugError.h"
#include "..\Utilities\CMemoryFree.h"
#include "..\Math\CMathFloat.h"
#include "CWinData.h"

namespace App
{
	// CWinInit class.
	// Class for initializing a window that will be used for this application.
	class CWinInit
	{
	public:
		CWinInit();
		CWinInit(const CWinInit& other);
		virtual ~CWinInit();

		int									Create(WNDPROC winProc, long application, HWND parent = NULL);
		
		void								UpdateRects();
		
		void								Release();
		
		inline WINDATA*						WindowData() const;
		inline void							WindowData(WINDATA* pWinData);

	private:
		WINDATA*							m_pWinData;
	};
		
	// Window data getter and setting

	inline WINDATA* CWinInit::WindowData() const
	{
		return m_pWinData;
	}

	inline void CWinInit::WindowData(WINDATA* pWinData)
	{
		m_pWinData = pWinData;
	}
};

#endif