//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CWaveFile.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CWAVEFILE_H
#define CWAVEFILE_H

#include <Windows.h>
#include <XAudio2.h>
#include "..\Globals\CGlobals.h"
#include "..\Utilities\CDebugError.h"

#define fourccRIFF "RIFF"
#define fourccDATA "data"
#define fourccFMT "fmt "
#define fourccWAVE "WAVE"

namespace Audio
{
	// Wave file header structure.
	struct WAVEHEADERTYPE
	{
		char			chunkId[4];
		u32				chunkSize;
		char			format[4];
		char			subChunkId[4];
		u32				subChunkSize;
		u16				audioFormat;
		u16				numChannels;
		u32				sampleRate;
		u32				bytesPerSecond;
		u16				blockAlign;
		u16				bitsPerSample;
		char			dataChunkId[4];
		u32				dataSize;
	};

	// CWaveFile class.
	// Class for openning and extracting data from a wave file.
	class CWaveFile
	{
	public:
		CWaveFile();
		CWaveFile(const CWaveFile& other);
		virtual ~CWaveFile();

		int									OpenFile(const std::string& filename, WAVEFORMATEXTENSIBLE& wfx, XAUDIO2_BUFFER& buffer);

	private:
	};
};

#endif