//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CConstantBuffer.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CCONSTANTBUFFER_H
#define CCONSTANTBUFFER_H

#include <d3d11.h>
#include <d3dx11.h>
#include "..\Utilities\CDebugError.h"
#include "..\Application\CDX11Object.h"

namespace GFX
{
	// CConstantBuffer class.
	// Class for create a constant buffer that can be used with shaders.
	class CConstantBuffer : public App::CDX11Object
	{
	public:
		CConstantBuffer();
		CConstantBuffer(const CConstantBuffer& other);
		virtual ~CConstantBuffer();

		int									Initialize(u32 bufferWidth, bool dynamic);
		
		int									ResetBuffer(void* updatedData);
		int									UpdateBuffer(void* updatedData);

		int									BindBufferVS(u32 startSlot);
		int									BindBufferHS(u32 startSlot);
		int									BindBufferDS(u32 startSlot);
		int									BindBufferPS(u32 startSlot);
		int									BindBufferGS(u32 startSlot);
		int									BindBufferCS(u32 startSlot);

		void								Release();

	private:
		u32									m_bufferWidth;
		ID3D11Buffer*						m_pCBuffer;
	};
};

#endif