//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CDebugRay.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CDebugRay.h"

namespace GFX
{
	CDebugRay::CDebugRay()
	{
	}

	CDebugRay::CDebugRay(const CDebugRay& other)
	{
	}

	CDebugRay::~CDebugRay()
	{
	}

	// Method for initializing a debug ray with a line.
	int CDebugRay::Initialize()
	{
		int retCode = Util::Err::NONE;

		AddLine(new DEBUG_LINE(Math::CVector3::Zero(), Math::CVector3::One()));

		if((retCode = CDebugBase::Initialize()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}

	// Method for rendering a ray with the correct length, and direction.
	int CDebugRay::Render()
	{
		int retCode = Util::Err::NONE;

		((CMatDebug*)m_pMaterial)->m_debugCBuffer.scale = m_ray.Direction() * m_ray.Distance();
		m_pTransform->Position(m_ray.Origin());
		m_pTransform->Update();

		if((retCode = CDebugBase::Render()) != Util::Err::NONE)
			return retCode;

		((CMatDebug*)m_pMaterial)->m_debugCBuffer.scale = Math::CVector3::One();

		return retCode;
	}
};