//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatDebug.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATDEBUG_H
#define CMATDEBUG_H

#include "CMaterial.h"
#include "..\Math\CMathColor.h"

namespace GFX
{
	// Debug material constant buffer.
	struct DEBUG_CBUFFER
	{
		Math::CColor						color;
		Math::CVector3						scale;
		float								padding0;
	};

	// CMatDebug class
	// Used primarily with debug line-list geometry.
	class CMatDebug : public CMaterial
	{
	public:
		CMatDebug();
		CMatDebug(const CMatDebug& other);
		virtual ~CMatDebug();

		int									Render() override;

		void								Release() override;
		
		DEBUG_CBUFFER						m_debugCBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif