//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatFT2Font.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATFT2FONT_H
#define CMATFT2FONT_H

#include "CMaterial.h"
#include "../Math/CMathColor.h"

namespace GFX
{
	// FreeType2 font constant buffer.
	struct FT2FONT_CBUFFER
	{
		Math::CColor						color;
		int									textured;
		int									pointFilter;
		float								padding0[2];
	};

	// CMatFT2Font class
	// FreeType2 font rendering material.
	class CMatFT2Font : public CMaterial
	{
	public:
		CMatFT2Font();
		CMatFT2Font(const CMatFT2Font& other);
		virtual ~CMatFT2Font();

		int									Render() override;

		void								Release() override;
		
		FT2FONT_CBUFFER						m_ft2CBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif