//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatParticle.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATPARTICLE_H
#define CMATPARTICLE_H

#include "CMaterial.h"
#include "..\Math\CMathColor.h"

namespace GFX
{
	// Particle material constant buffer.
	struct PARTICLE_CBUFFER
	{
		Math::CColor						color;
		Math::CVector4						cameraPosition;
		float								softness;
		float								time;
		float								screenWidth;
		float								screenHeight;
		int									billboardType;
		float								padding0[3];
	};

	class CMatParticle : public CMaterial
	{
	public:
		CMatParticle();
		CMatParticle(const CMatParticle& other);
		virtual ~CMatParticle();

		int									Render() override;
		void								Release() override;
		
		PARTICLE_CBUFFER					m_particleCBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif