//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatSkydome.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATSKYDOME_H
#define CMATSKYDOME_H

#include "CMaterial.h"

namespace GFX
{
	// Skydome material constant buffer.
	struct SKYDOME_CBUFFER
	{
		Math::CColor						color;
	};

	// CMatSkydome class
	// Material for rendering a skydome in the scene.
	class CMatSkydome : public CMaterial
	{
	public:
		CMatSkydome();
		CMatSkydome(const CMatSkydome& other);
		virtual ~CMatSkydome();

		int									Render() override;
		void								Release() override;
		
		SKYDOME_CBUFFER						m_skydomeBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif