//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatUIImage.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATUIIMAGE_H
#define CMATUIIMAGE_H

#include "CMaterial.h"
#include "../Math/CMathColor.h"

namespace GFX
{
	// UI image constant buffer.
	struct UIIMAGE_CBUFFER
	{
		Math::CColor						color;
		int									textured;
		int									pointFilter;
		Math::CVector2						padding0;
	};

	// CMatUIImage class.
	// Material class for rendering UI image instances.
	class CMatUIImage : public CMaterial
	{
	public:
		CMatUIImage();
		CMatUIImage(const CMatUIImage& other);
		virtual ~CMatUIImage();

		int									Render() override;

		void								Release() override;
		
		UIIMAGE_CBUFFER						m_imageCBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif