//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CTextureProjector.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CTEXTUREPROJECTOR_H
#define CTEXTUREPROJECTOR_H

#include "..\Application\CDX11Object.h"
#include "CTextureProjection.h"
#include "..\Math\CMathCamera.h"

namespace GFX
{
	// CTextureProjector class
	// Class for creating a texture projector in a scene.
	// Used with deferred rendering.
	class CTextureProjector
	{
	public:
		CTextureProjector();
		CTextureProjector(const CTextureProjector& other);
		virtual ~CTextureProjector();

		int									Initialize();
		int									Update();
		void								Release();

		inline Math::CCamera*				Camera() const;
		inline void							Camera(Math::CCamera* pCamera);

	private:
		Math::CCamera*						m_pProjectionCamera;
	};

	// Camera getter and setter.

	inline Math::CCamera* CTextureProjector::Camera() const
	{
		return m_pProjectionCamera;
	}

	inline void CTextureProjector::Camera(Math::CCamera* pCamera)
	{
		m_pProjectionCamera = pCamera;
	}
};

#endif