//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathRay.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATHRAY_H
#define CMATHRAY_H

#include "CMathVector3.h"

namespace Math
{
	class CRay
	{
	public:
		CRay();
		CRay(CVector3 origin, CVector3 direction, float distance);
		CRay(const CRay& other);
		CRay(CRay&& other);
		virtual ~CRay();

		CRay& operator = (const CRay& ray) = default;

		inline CVector3						Origin() const;
		inline void							Origin(const CVector3& origin);

		inline CVector3						Direction() const;
		inline void							Direction(const CVector3& direction);

		inline float						Distance() const;
		inline void							Distance(float distance);

	private:
		CVector3							m_origin;
		CVector3							m_direction;
		float								m_distance;
	};

	// Orgin getter and setter.

	inline CVector3 CRay::Origin() const
	{
		return m_origin;
	}

	inline void CRay::Origin(const CVector3& origin)
	{
		m_origin = origin;
	}

	// Direction getter and setter.

	inline CVector3 CRay::Direction() const
	{
		return m_direction;
	}

	inline void CRay::Direction(const CVector3& direction)
	{
		m_direction = direction;
	}

	// Distance getter and setter.

	inline float CRay::Distance() const
	{
		return m_distance;
	}

	inline void CRay::Distance(float distance)
	{
		m_distance = distance;
	}
};

#endif