//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathSphere.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CMathSphere.h"

namespace Math
{
	CSphere::CSphere()
	{
		center = 0;
		radius = 0;
	}

	CSphere::CSphere(const CVector3& Center, float Radius)
	{
		center = Center;
		radius = Radius;
	}

	CSphere::CSphere(float X, float Y, float Z, float Radius)
	{
		x = X;
		y = Y;
		z = Z;
		radius = Radius;
	}

	CSphere::CSphere(const CSphere& other)
	{
		center = other.center;
		radius = other.radius;
	}

	//
	// Conditional operators.
	//

	bool CSphere::operator == (const CSphere& sphere) const
	{
		return (center == sphere.center);
	}

	bool CSphere::operator != (const CSphere& sphere) const
	{
		return (center != sphere.center);
	}
};