//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathSphere.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATHSPHERE_H
#define CMATHSPHERE_H

#include "CMathVector3.h"
#include "CMathFloat.h"

namespace Math
{
	// CSphere class.
	// Class for creating a sphere bounding volume.
	class CSphere
	{
	public:
		union
		{
			struct
			{
				float x, y, z;
			};

			CVector3 center;
		};

		float radius;

	public:
		CSphere();
		CSphere(const CVector3& Center, float Radius);
		CSphere(float X, float Y, float Z, float Radius);
		CSphere(const CSphere& other);

		bool operator == (const CSphere& sphere) const;
		bool operator != (const CSphere& sphere) const;
	};
};

#endif