//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: UI\CUIObject.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CUIOBJECT_H
#define CUIOBJECT_H

#include "..\Application\CDX11Object.h"
#include "CUIFontRenderer.h"
#include "CUIImage.h"
#include "..\Application\CInput.h"
#include "..\Utilities\CTimer.h"

namespace UI
{
	// CUIObject class
	// Base class for UI objects.
	class CUIObject : public App::CDX11Object
	{
	public:
		CUIObject();
		CUIObject(const CUIObject& other);
		virtual ~CUIObject();

		virtual int							Initialize();
		virtual int							Update();
		virtual int							Render();
		virtual void						Release();

		inline float						Fade() const;
		inline void							Fade(float fade);
		
	protected:
		virtual void						CheckInteraction();

		u32									m_fontCount;
		u32									m_imageCount;

		bool								m_bHovered;
		bool								m_bClicked;
		Math::CVector4						m_bounds;

		float								m_fade;

		CFontRenderer*						m_pFont;
		CFontRenderer**						m_pFonts;
		CImage*								m_pImage;
		CImage**							m_pImages;

		App::CInput*						m_pInput;
		Util::CTimer*						m_pTimer;

	private:
	};

	// UI object alpha fade value setters and getters.

	inline float CUIObject::Fade() const
	{
		return m_fade;
	}
	inline void CUIObject::Fade(float fade)
	{
		m_fade = fade;
	}
};

#endif