//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Utilities\CDataQueue.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CDataQueue.h"

namespace Util
{
	CPtrQueue::CPtrQueue()
	{
		m_pHead = NULL;
		m_pTail = NULL;
	}

	CPtrQueue::CPtrQueue(const CPtrQueue& other)
	{
	}

	CPtrQueue::CPtrQueue(CPtrQueue&& other)
	{
	}

	CPtrQueue::~CPtrQueue()
	{
		Release();
	}

	// Method for pushing data to the queue.
	void CPtrQueue::Push(void* data)
	{
		// Empty queue?
		if(m_pHead == NULL)
		{
			m_pHead = new NODE();
			m_pHead->data = data;
			m_pHead->next = NULL;
			m_pTail = m_pHead;
			return;
		}

		// Non-emptry queue?
		if(m_pTail)
		{
			NODE* ptr = new NODE();
			ptr->data = data;
			ptr->next = NULL;
			m_pTail->next = ptr;
			m_pTail = ptr;
		}
	}

	// Method for popping data from the queue.
	void* CPtrQueue::Pop()
	{
		if(m_pHead == NULL)
			return NULL;

		NODE* temp = m_pHead;
		void* data = temp->data;
		if(m_pHead->next)
		{
			m_pHead = m_pHead->next;
		}
		else
		{
			delete temp;
			m_pHead = NULL;
		}

		return data;
	}

	// Method for releasing data from the queue.
	void CPtrQueue::Release()
	{
		if(m_pHead == NULL)
			return;

		NODE* cur = m_pHead;
		NODE* ptr;

		while(cur)
		{
			ptr = cur;
			cur = cur->next;
			delete ptr;
		}

		m_pHead = NULL;
		m_pTail = NULL;
	}
};