//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CParticleFire.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CPARTICLEFIRE_H
#define CPARTICLEFIRE_H

#include <Graphics\CParticleDevice.h>
#include <Graphics\CTextureList.h>
#include "CMatFireEffect.h"

namespace GFX
{
	// CParticleFire class.
	// Class that creates a particle fire effect. Primarily used with the CFireObject class.
	class CParticleFire : public CParticleDevice
	{
	public:
		CParticleFire();
		CParticleFire(const CParticleFire& other);
		virtual ~CParticleFire();

		int									Initialize() override;
		int									Update() override;
		int									Render() override;

		void								Release() override;

		inline void							ColorTextureFilename(const char* filename);
		inline void							NoiseTextureFilename(const char* filename);
		inline void							AlphaTextureFilename(const char* filename);

	private:
		std::string							m_colorTextureFilename;
		std::string							m_noiseTextureFilename;
		std::string							m_alphaTextureFilename;
	};

	// Texture filename getters and setters.

	inline void CParticleFire::ColorTextureFilename(const char* filename)
	{
		m_colorTextureFilename = filename;
	}

	inline void CParticleFire::NoiseTextureFilename(const char* filename)
	{
		m_noiseTextureFilename = filename;
	}

	inline void CParticleFire::AlphaTextureFilename(const char* filename)
	{
		m_alphaTextureFilename = filename;
	}
};

#endif